/ If you know ASM and understand this. Feel free to tinker and add functions. If you don't
/ know ASM , I would recommend just skipping this file and remember to include it right
/ after your Title statement.

/ A word to ASM buffs: When you look at the resulting source code, you will see several places for
/ optimization (mostly around assignments and several math statements next to each other). Feel
/ free to optimize but don't do it until you have your final version. The compiler will
/ just write over your precious optimizations.

/ Also send any additional useful System Functions you write or add (you can tell I am lacking in
/ lots of areas, mainly many gfx routines) In fact, email me when you have incorporated sprites
/ with clipping, grayscale sprite routines, any link routines THAT WORK, sound stuff as well as
/ advanced math stuff you may come up with (simple trig functions, 16-bit multiplication, etc.)

SystemFunction(Draw8, syspointerarg0, sysbytearg0, sysbytearg1)
DRAW8:
;ors an 8 pixel wide nonaligned sprite
    ld de,(SYSBYTEARG0)
    ld h, 0
    ld a,d
    add a,a
    add a,a
    ld l,a
    ld a,e
    rra
    add hl,hl
    rra
    add hl,hl
    rra
    or l
    ld l,a
    ld bc, (VIDEOBUFF)
    add hl,bc
    ld a,e
    and %00000111
    ld ix, (SYSPOINTERARG0)
    ld c, a
    ld a,(SPRITE8HEIGHT)
    ld b, a
ds21lp:
    push bc
    ld a, c
    ld c, (ix+0)
    or a
    jr z, TI_D8_skiprotate
    ld b, a
    xor a
ds21lp2:
    rr c
    rra
    djnz ds21lp2
TI_D8_skiprotate:
    ld b,a
    ld a,c
    or (hl)
    ld (hl),a
    inc hl
    ld a,b
    or (hl)
    ld (hl),a
    inc ix
    ld bc, 15
    add hl, bc
    pop bc
    djnz ds21lp
    ret
EndSystemFunction

SystemFunction(Draw88, syspointerarg0, sysbytearg0, sysbytearg1)
DRAW88:
    SysFuncRequire(Draw8)
    ld a, 8
    ld (SPRITE8HEIGHT), a
    jp DRAW8
EndSystemFunction

SystemFunction(Draw8H, syspointerarg0, sysbytearg0, sysbytearg1, sprite8height)
    SysFuncRequire(Draw8)
DRAW8H .equ DRAW8
EndSystemFunction

SystemFunction(Draw16, syspointerarg0, sysbytearg0, sysbytearg1)
DRAW16:
;ors an 16 pixel wide nonaligned sprite
    ld de,(SYSBYTEARG0)
    ld h, 0
    ld a,d
    add a,a
    add a,a
    ld l,a
    ld a,e
    rra
    add hl,hl
    rra
    add hl,hl
    rra
    or l
    ld l,a
    ld bc, (VIDEOBUFF)
    add hl,bc
    ld a,e
    and %00000111
    ld ix, (SYSPOINTERARG0)
    ld c, a
    ld a,(SPRITE16HEIGHT)
    ld b, a
ds2116lp:
    push bc
    ld a, c
    ld c, (ix+0)
    ld d, (ix+1)
    or a
    jr z, TI_D16_skiprotate
    ld b, a
    xor a
ds2116lp2:
    rr c
    rr d
    rra
    djnz ds2116lp2
TI_D16_skiprotate:
    ld b,a
    ld a,c
    or (hl)
    ld (hl),a
    inc hl
    ld a,d
    or (hl)
    ld (hl),a
    inc hl    
    ld a,b
    or (hl)
    ld (hl),a
    inc ix
    inc ix
    ld bc, 14
    add hl, bc
    pop bc
    djnz ds2116lp
    ret
EndSystemFunction

SystemFunction(Draw1616, syspointerarg0, sysbytearg0, sysbytearg1)
DRAW1616:
    SysFuncRequire(Draw16)
    ld a, 16
    ld (SPRITE16HEIGHT), a
    jp DRAW16
EndSystemFunction

SystemFunction(Draw16H, syspointerarg0, sysbytearg0, sysbytearg1, sprite16height)
    SysFuncRequire(Draw16)
DRAW16H .equ DRAW16
EndSystemFunction

SystemFunction(TotalVertLine, sysbytearg0)
TOTALVERTLINE:
;draws a vertical line down the screen
    ld a,(SYSBYTEARG0)
    ld d,a
    and %00000111
    add a,8
    ld b,a
    ld a,128
vlineblah:
    rrca
    djnz vlineblah
    push af
    ld a,d
    rra
    rra
    rra
    and %00001111
    ld c,a
    ld hl,(VIDEOBUFF)
    add hl,bc
    pop af
    ld c,a
    ld de,16
    ld b,64
vlineblah2:
    or (hl)
    ld (hl),a
    ld a,c
    add hl,de
    djnz vlineblah2
    ret
EndSystemFunction

SystemFunction(TotalHorzLine, sysbytearg0)
TOTALHORZLINE:
; draws a horizontal line across the screen
    ld hl, (SYSBYTEARG0)
    ld h, 0
    add hl,hl
    add hl,hl
    add hl,hl

    add hl,hl
    ld de, (VIDEOBUFF)
    add hl,de
    ld b,16
hlineblah:
    ld (hl),255
    inc hl
    djnz hlineblah
    ret
EndSystemFunction


SystemFunction(ScrollDown, syspointerarg0, syspointerarg1)
SCROLLDOWN:
; scrolls buffer in pointer 0 down 1 pixel, uses 16-byte buffer pointed to by pointer 1 for temp. storage
  ld hl,(SYSPOINTERARG0)
  ld de,(SYSPOINTERARG1)
  push de
  push hl
  ld bc, 1008
  add hl,bc
  push bc
  push hl
  push hl
  ld bc, 16
  push bc
  ldir
  pop hl
  pop de
  dec hl
  add hl,de
  ex de,hl
  pop hl
  dec hl
  pop bc
  lddr
  pop de
  pop hl
  ld bc,16
  ldir
  ret
EndSystemFunction

SystemFunction(TI_FindPixel, sysbytearg0, sysbytearg1)
TI_FINDPIXEL:
; typical find pixel routine
  ld de, (SYSBYTEARG0)
; Modified version of Dan Eble's and James Yopp's findpixel routine
  ld hl,TI_FP_Bits
  ld a,e
  and $07         ; a = bit offset
  add a,l
  ld l,a
  adc a,h
  sub l
  ld h,a
  ld c,(hl)       ; c = bitmask for (hl)
  ld hl,TI_FP_RLD
  ld (hl),d
  ld a,e          ; a = x/8 (byte offset within row)
  rrca
  rrca   
  rrca
  rld
  ld l,(hl)
  and %00000011
  ld h,a          ; hl -> byte in vid mem
  ld de, (VIDEOBUFF)
  add hl,de  
  ld a,c          ; now a = bitmask for (hl)
  ret
TI_FP_RLD:  .db $00
TI_FP_Bits: .db $80,$40,$20,$10,$08,$04,$02,$01
EndSystemFunction
  
SystemFunction(SetPixel, sysbytearg0, sysbytearg1)
SETPIXEL:
  SysFuncRequire(TI_FindPixel)
; turns the pixel on at the specified x and y
  call TI_FINDPIXEL
  or (hl)
  ld (hl), a
  ret
EndSystemFunction
  
SystemFunction(ResetPixel, sysbytearg0, sysbytearg1)
RESETPIXEL:
  SysFuncRequire(TI_FindPixel)
; turns pixel off
  call TI_FINDPIXEL
  cpl
  and (hl)
  ld (hl), a
  ret
EndSystemFunction

SystemFunction(InvPixel, sysbytearg0, sysbytearg1)
INVPIXEL:
  SysFuncRequire(TI_FindPixel)
  call TI_FINDPIXEL
  xor (hl)
  ld (hl), a
  ret
EndSystemFunction

SystemFunction(TestPixel, sysbytearg0, sysbytearg1)
TESTPIXEL:
  SysFuncRequire(TI_FindPixel)
  call TI_FINDPIXEL
  and (hl)
  ld (SUCCESS), a
  ret
EndSystemFunction

SystemFunction(VertLine, sysbytearg0, sysbytearg1, sysbytearg2)
VERTLINE:
  SysFuncRequire(TI_FindPixel)
  call TI_FINDPIXEL
  ld bc, (SYSBYTEARG1)
  ld de,SCREENWIDTHBYTES
TI_VertLineLoop:
  push af
  or (hl)
  ld (hl),a
  pop af
  add hl,de
  djnz TI_VertLineLoop
  ret
EndSystemFunction
  
SystemFunction(HorzLine, sysbytearg0, sysbytearg1, sysbytearg2)
HORZLINE:
  SysFuncRequire(TI_FindPixel)
  call TI_FINDPIXEL
  ld bc, (SYSBYTEARG1)
TI_HorzLineLoop:
  push af
  or (hl)
  ld (hl),a
  pop af
  rrca
  jr nc, TI_HorzLineB
  inc hl
TI_HorzLineB
  djnz TI_HorzLineLoop
  ret
EndSystemFunction

SystemFunction(DiagonalRightLine, sysbytearg0, sysbytearg1, sysbytearg2)
DIAGONALRIGHTLINE:
  SysFuncRequire(TI_FindPixel)
  call TI_FINDPIXEL
  ld bc, (SYSBYTEARG1)
  ld de,SCREENWIDTHBYTES
TI_DiagonalRightLineLoop:
  push af
  or (hl)
  ld (hl),a
  pop af
  rrca
  jr nc, TI_DiagonalRightLineB
  inc hl
TI_DiagonalRightLineB
  add hl,de
  djnz TI_DiagonalRightLineLoop
  ret
EndSystemFunction

SystemFunction(DiagonalLeftLine, sysbytearg0, sysbytearg1, sysbytearg2)
DIAGONALLEFTLINE:
  SysFuncRequire(TI_FindPixel)
  call TI_FINDPIXEL
  ld bc, (SYSBYTEARG1)
  ld de,SCREENWIDTHBYTES
TI_DiagonalLeftLineLoop:
  push af
  or (hl)
  ld (hl),a
  pop af
  rlca
  jr nc, TI_DiagonalLeftLineB
  dec hl
TI_DiagonalLeftLineB:
  add hl,de
  djnz TI_DiagonalLeftLineLoop
  ret
EndSystemFunction


SystemFunction(InverseTextOn)
INVERSETEXTON:
  set textInverse,(iy+textflags)
  ret
EndSystemFunction

SystemFunction(InverseTextOff)
INVERSETEXTOFF:
  res textInverse,(iy+textflags)
  ret
EndSystemFunction